'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _classnames=require('classnames');var _classnames2=_interopRequireDefault(_classnames);var _propTypes=require('prop-types');var _propTypes2=_interopRequireDefault(_propTypes);var _react=require('react');var _react2=_interopRequireDefault(_react);var _reactMaterialize=require('react-materialize');function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}/**
* This React component shows a switch to choose one of the theme's buttons colors
* available in the UI default theme.
* The component should be used in a form to configure a button that can accept a color depending
* on the user's choice.
*
* Default color is 'secondary'.
* Available colors are: 'primary', 'secondary', 'inconspicuous'.
*
* @example <caption>Can use it in React JSX syntax</caption>
* <ActionColorSwitch
*     theme={this.props.theme}
*     animationLevel={this.props.animationLevel}
*     defaultColor="primary"
*     onChange={(color) => { this.currentColor = color; }}
* />
*
* @see https://github.com/gxapplications/asterism/blob/master/lib/plugins/navigation-tools/go-to-path-button/setting-panel.jsx
* @hideconstructor
* @memberof module:Asterism
* @public
*/var ActionColorSwitch=function(_React$Component){_inherits(ActionColorSwitch,_React$Component);/**
   * React properties to use on this component.
   *
   * @property {object} theme - The asterism theme object. Often available from the parent component, or in the mainState object of a context.
   * @property {number} animationLevel - The asterism main parameter for visual animations. Often available from the parent component, or in the mainState object of a context.
   * @property {string} defaultColor - The default color to set to the component when mounted. By default, will be "secondary".
   * @property {func} onChange - A function called as a callback when the user changes the color. Take color as argument.
   * @public
   */function ActionColorSwitch(props){_classCallCheck(this,ActionColorSwitch);var _this=_possibleConstructorReturn(this,(ActionColorSwitch.__proto__||Object.getPrototypeOf(ActionColorSwitch)).call(this,props));_this.state={color:props.defaultColor};return _this;}/**
   * Default properties values.
   * @property {string} defaultColor - "secondary"
   * @public
   */_createClass(ActionColorSwitch,[{key:'componentDidUpdate',value:function componentDidUpdate(prevProps){if(prevProps.defaultColor!==this.props.defaultColor){return this.setState({color:this.props.defaultColor});}}},{key:'render',value:function render(){var color=this.state.color;var theme=this.props.theme;return _react2.default.createElement(_reactMaterialize.Row,{className:'actionColorSwitch'},_react2.default.createElement('button',{className:(0,_classnames2.default)('col s4 fluid',color==='primary'?'btn-flat':'btn',theme.actions.primary),onClick:this.selectColor.bind(this,'primary')},_react2.default.createElement('i',{className:'material-icons left'},color==='primary'?'radio_button_checked':'radio_button_unchecked'),'Primary'),_react2.default.createElement('button',{className:(0,_classnames2.default)('col s4 fluid',color==='secondary'?'btn-flat':'btn',theme.actions.secondary),onClick:this.selectColor.bind(this,'secondary')},_react2.default.createElement('i',{className:'material-icons left'},color==='secondary'?'radio_button_checked':'radio_button_unchecked'),'Secondary'),_react2.default.createElement('button',{className:(0,_classnames2.default)('col s4 fluid',color==='inconspicuous'?'btn-flat':'btn',theme.actions.inconspicuous),onClick:this.selectColor.bind(this,'inconspicuous')},_react2.default.createElement('i',{className:'material-icons left'},color==='inconspicuous'?'radio_button_checked':'radio_button_unchecked'),'Neutral'));}},{key:'selectColor',value:function selectColor(color){this.setState({color:color});this.props.onChange(color);}}]);return ActionColorSwitch;}(_react2.default.Component);ActionColorSwitch.propTypes={theme:_propTypes2.default.object.isRequired,animationLevel:_propTypes2.default.number.isRequired,defaultColor:_propTypes2.default.string,onChange:_propTypes2.default.func.isRequired};ActionColorSwitch.defaultProps={defaultColor:'secondary'};exports.default=ActionColorSwitch;