'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _classnames=require('classnames');var _classnames2=_interopRequireDefault(_classnames);var _propTypes=require('prop-types');var _propTypes2=_interopRequireDefault(_propTypes);var _react=require('react');var _react2=_interopRequireDefault(_react);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true});}else{obj[key]=value;}return obj;}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}/**
* This React component shows a collection of items, most often clickable for edition.
* At the end of the list, an item can be added to let add more items.
*
* Default header is to have no header (empty string)
*
* @example <caption>Use it in React JSX syntax</caption>
* <CollectionSetting
*     theme={theme}
*     animationLevel={animationLevel}
*     list={
*         elements.map((el) => ({
*             title: el.name || 'Unnamed',
*             icon: 'favorite',
*             onClick: this.configureElement.bind(this, el),
*             details: el.details || 'No more details',
*             css: 'my-class',
*             secondary: {
*                 icon: 'more_vert',
*                 onClick: () => {},
*                 css: 'my-secondary-class'
*             }
*         }))
*     }
*     header='My elements list'
*     addElement={{
*         empty: { title: 'Add your first element here', icon: 'add' },
*         trailing: { title: 'Add an element' },
*         onClick: this.addElement.bind(this)
*     }}
* />
*
* @see https://github.com/gxapplications/asterism-plugin-ipcam/blob/master/lib/settings.jsx
* @hideconstructor
* @memberof module:Asterism
* @public
*/var CollectionSetting=function(_React$Component){_inherits(CollectionSetting,_React$Component);function CollectionSetting(){_classCallCheck(this,CollectionSetting);return _possibleConstructorReturn(this,(CollectionSetting.__proto__||Object.getPrototypeOf(CollectionSetting)).apply(this,arguments));}_createClass(CollectionSetting,[{key:'render',/**
   * React properties to use on this component.
   *
   * @property {object} theme - The asterism theme object. Often available from the parent component, or in the mainState object of a context.
   * @property {number} animationLevel - The asterism main parameter for visual animations. Often available from the parent component, or in the mainState object of a context.
   * @property {object[]} list - The elements as an objects array. See above example for object attributes to insert here.
   * @property {string} header - The header displayed above the collection.
   * @property {object} addElement - An object containing empty list case and a 'add element' trailing item. See above example for object attributes to insert here.
   * @public
   */value:function render(){var _props=this.props,animationLevel=_props.animationLevel,list=_props.list,header=_props.header,addElement=_props.addElement;var waves=animationLevel>=2?'waves-effect waves-light':undefined;return _react2.default.createElement('div',{className:'collection'},header&&header.length?_react2.default.createElement('div',{className:'collection-item'},_react2.default.createElement('h5',{className:'truncate'},header)):null,list.map(function(el,idx){return _react2.default.createElement('a',{key:idx,className:(0,_classnames2.default)('collection-item avatar activator',_defineProperty({},waves,el.onClick!==undefined),el.css),href:'#!',onClick:el.onClick},_react2.default.createElement('i',{className:(0,_classnames2.default)('material-icons circle activator',el.icon)},el.icon||(el.onClick?'menu':'')),_react2.default.createElement('span',{className:'title truncate activator'},el.title),el.details?_react2.default.createElement('p',{className:'truncate activator'},el.details):null,el.secondary?_react2.default.createElement('div',{onClick:el.secondary.onClick,className:(0,_classnames2.default)('secondary-content',_defineProperty({},waves,el.secondary.onClick!==undefined),el.secondary.css)},_react2.default.createElement('i',{className:(0,_classnames2.default)('material-icons',el.secondary.icon)},el.secondary.icon||'more_vert')):null);}),list.length?addElement&&addElement.trailing?_react2.default.createElement('a',{href:'#!',className:(0,_classnames2.default)('collection-item avatar activator trailing add',waves),onClick:addElement.onClick},_react2.default.createElement('i',{className:'material-icons circle activator'},addElement.trailing&&addElement.trailing.icon||'add'),_react2.default.createElement('span',{className:'title truncate activator'},addElement.trailing&&addElement.trailing.title||'Add a new element')):null:addElement&&addElement.empty?_react2.default.createElement('a',{href:'#!',className:(0,_classnames2.default)('collection-item big-avatar activator empty add',waves),onClick:addElement.onClick},_react2.default.createElement('i',{className:'material-icons circle activator'},addElement.empty&&addElement.empty.icon||'add'),_react2.default.createElement('span',{className:'title truncate activator'},addElement.empty&&addElement.empty.title||'Add a first element')):_react2.default.createElement('a',{nohref:true,className:(0,_classnames2.default)('collection-item big-avatar activator empty add')},_react2.default.createElement('span',{className:'title truncate activator'},'There is nothing to show here.')));}/**
   * Default properties values.
   * @property {string} header - ""
   * @public
   */}]);return CollectionSetting;}(_react2.default.Component);CollectionSetting.propTypes={theme:_propTypes2.default.object.isRequired,animationLevel:_propTypes2.default.number.isRequired,list:_propTypes2.default.array.isRequired,header:_propTypes2.default.string,addElement:_propTypes2.default.object};CollectionSetting.defaultProps={header:''};exports.default=CollectionSetting;