'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _react=require('react');var _react2=_interopRequireDefault(_react);var _additionalItem=require('./additional-item');var _additionalItem2=_interopRequireDefault(_additionalItem);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}/** @private */var BasicItemFactory=function(){function BasicItemFactory(_ref){var localStorage=_ref.localStorage,serverStorage=_ref.serverStorage,mainState=_ref.mainState,theme=_ref.theme,privateSocket=_ref.privateSocket,publicSockets=_ref.publicSockets,services=_ref.services;_classCallCheck(this,BasicItemFactory);this.context={localStorage:localStorage,serverStorage:serverStorage,mainState:mainState,theme:theme,privateSocket:privateSocket,publicSockets:publicSockets,services:services};this.items=this.constructor.generateItems(this);}_createClass(BasicItemFactory,[{key:'getAdditionalItems',value:function getAdditionalItems(category){// here we can filter more depending on the context (if settings required before to show these items)
return Object.values(this.items).map(function(i){return i.additionalItem;}).filter(function(ai){return ai.category===category;});}},{key:'instantiateNewItem',value:function instantiateNewItem(additionalItemId,id,settingPanelCallback){var _this=this;return this.saveItem(id,{},additionalItemId).then(function(){return _this.items[additionalItemId].newInstance(id,settingPanelCallback,_this.items[additionalItemId].dimensions,_this.context);});}},{key:'instantiateItem',value:function instantiateItem(id,settingPanelCallback){var _this2=this;// must return { item, settingPanel }
// OR a promise resolving the same structure,
// OR throw an error with error.status = 404 if not found (other errors won't be caught).
return this.context.serverStorage.getItemForPath(id).then(function(_ref2){var additionalItemId=_ref2.additionalItemId,params=_ref2.params;return _this2.items[additionalItemId].restoreInstance(id,params,settingPanelCallback,_this2.items[additionalItemId].dimensions,_this2.context);});}},{key:'saveItem',value:function saveItem(id,params,additionalItemId){var _this3=this;// must return a Promise that resolves once save is persisted and can be retrieved by a read operation.
if(!additionalItemId){return this.context.serverStorage.getItemForPath(id).then(function(data){return _this3.context.serverStorage.setItemForPath(id,{additionalItemId:data.additionalItemId,params:params});});}return this.context.serverStorage.setItemForPath(id,{additionalItemId:additionalItemId,params:params});}},{key:'removeItem',value:function removeItem(id){// This is an async event. Do not return a Promise when finished. Can be overridden.
console.log('Ok, item #'+id+' is removed.');}}],[{key:'generateItems',value:function generateItems(itemFactory){// This method is overridden by builder into inherited prototype during build.
return{};}}]);return BasicItemFactory;}();/** @private */var ItemLinker=function(){function ItemLinker(){_classCallCheck(this,ItemLinker);}_createClass(ItemLinker,[{key:'receiveItemSettingPanel',value:function receiveItemSettingPanel(itemSettingPanel){this.itemSettingPanel=itemSettingPanel;this.linkBoth();}},{key:'receiveItem',value:function receiveItem(item){this.item=item;this.linkBoth();}},{key:'linkBoth',value:function linkBoth(){if(this.item&&this.itemSettingPanel&&this.itemSettingPanel.state.item!==this.item){this.itemSettingPanel.setState({item:this.item,params:this.item.state.params||this.item.props.initialParams});}}}]);return ItemLinker;}();/**
* This class is instantiated through an itemFactoryBuilder, to add an item type with all its attributes and caracteristics.
*
* This builder is given by the following method, as example:
* const itemTypeBuilder = new ItemFactoryBuilder().newItemType('item_type_id', AdditionalItem.categories.DOMOTICS)
*
* You can chain methods to complete your item type description and characteristics.
* Once you chained all needed methods to build you item type, call .build() method to register it in _asterism_.
*
* Mandatory attributes/calls:
* - id and category (through the ItemFactoryBuilder().newItemType(id, category) method),
* - title (through .withDescription(title, text)),
* - if you need to call .settingPanelWithHeader() - optional - do it before both below methods,
* - either .newInstanceWithoutInitialSetting() XOR newInstanceFromInitialSetting() must be called,
* - ItemClass and SettingPanelClass (through .existingInstance(ItemClass, SettingPanelClass))
* - .acceptDimensions() must add at least one dimension.
*
* @example
* const builder = new ItemFactoryBuilder()
* .newItemType('unique_item_type_id', AdditionalItem.categories.DOMOTICS)
*   .withDescription('Great Item')
*   .settingPanelWithHeader('Great Item settings', 'touch_app') // optional override, but always before *Instance*() calls...
*   .newInstanceFromInitialSetting(1, 2, GreatItemSettingPanel)
*   .existingInstance(GreatItem, GreatItemSettingPanel)
*   .acceptDimensions([
*     { w: 2, h: 1 },
*     { w: 1, h: 2 }
*   ])
*   .build()
* .newItemType(... // You can chain multiple item types
*
*
* @see https://github.com/gxapplications/asterism/blob/master/lib/plugins/scenarii/item-factory.jsx
* @memberof module:Asterism
* @public
*/var ItemTypeBuilder=function(){function ItemTypeBuilder(itemFactoryBuilder,id,category){_classCallCheck(this,ItemTypeBuilder);this.itemFactoryBuilder=itemFactoryBuilder;this.id=id;// dev mode only
if(process.env.NODE_ENV!=='production'){if(this.itemFactoryBuilder.itemsToBuild[this.id]){throw new Error('This additionalItem id already exists.');}}this.category=category;this.title=id;this.description='';this.newInstance=null;this.restoreInstance=null;this.dimensions=[];}/**
   * Adds a mandatory title (in English) and an optional description text (recommended)
   *
   * @param {string} title - Mandatory title, in English. Please keep it really short. Not much place to display it.
   * @param {string} text - The optional description to complete your item title with a small explanation of the item type purpose. 1 or 2 lines.
   * @returns {object} - This object, to chain methods
   * @public
   */_createClass(ItemTypeBuilder,[{key:'withDescription',value:function withDescription(title,text){this.title=title;this.description=text||'';return this;}/**
   * Use this if you can instantiate an item without displaying a settings panel before. In other words, if an item instance
   * can have default params values (that should be kept in default state most of the time) then you don't need to show settings
   * panel at creation: the settings panel will be available after creation, to update the item if needed.
   *
   * @param {class} ItemClass - The class to use to instantiate the item. It's a class extending Item class, often in a .jsx format.
   * @param {integer} preferredHeight - The default height of the new item instance on the dashboard. From 1 to 5.
   * @param {integer} preferredWidth - The default width of the new item instance on the dashboard. From 1 to 3.
   * @param {class} SettingPanelClass - The class of setting panel to use to update item params. Extending ItemSettingPanel class, often in a .jsx format.
   * @see https://github.com/gxapplications/asterism/blob/master/lib/plugins/scenarii/action-button/item.jsx
   * @returns {object} - This object, to chain methods
   * @public
   */},{key:'newInstanceWithoutInitialSetting',value:function newInstanceWithoutInitialSetting(ItemClass,preferredHeight,preferredWidth,SettingPanelClass){if(this.newInstance){throw new Error('You cannot call newInstance*() multiple times.');}var typeId=this.id;var settingIcon=this.settingPanelIcon;var settingTitle=this.settingPanelTitle||this.title;this.newInstance=function(itemFactory){return function(id,settingPanelCallback,acceptedDimensions,context){var itemLinker=new ItemLinker();var item=_react2.default.createElement(ItemClass,{id:id,context:context,ref:function ref(c){return itemLinker.receiveItem(c);},acceptedDimensions:acceptedDimensions});var settingPanel=_react2.default.createElement(SettingPanelClass,{ref:function ref(c){return itemLinker.receiveItemSettingPanel(c);},icon:settingIcon,title:settingTitle,id:id,item:item,context:context,save:function save(newParams){return itemFactory.saveItem(id,newParams,typeId);},acceptedDimensions:acceptedDimensions,settingPanelCallback:settingPanelCallback});return{id:id,item:item,preferredHeight:preferredHeight,preferredWidth:preferredWidth,settingPanel:settingPanel};};};return this;}/**
   * Use this instead of .newInstanceWithoutInitialSetting() if you need to show setting panel before to be able to instantiate item.
   * The given panel will open, and after its .next() call, will close to create the new item. This solution is recommended when you need params from
   * the user that you cannot give by default (and then cannot create an item without them).
   *
   * @param {integer} preferredHeight - The default height of the new item instance on the dashboard. From 1 to 5.
   * @param {integer} preferredWidth - The default width of the new item instance on the dashboard. From 1 to 3.
   * @param {class} SettingPanelClass - The class of setting panel to use to set initial item params. Extending ItemSettingPanel class, often in a .jsx format.
   * @returns {object} - This object, to chain methods
   * @public
   */},{key:'newInstanceFromInitialSetting',value:function newInstanceFromInitialSetting(preferredHeight,preferredWidth,SettingPanelClass){if(this.newInstance){throw new Error('You cannot call newInstance*() multiple times.');}var typeId=this.id;var settingIcon=this.settingPanelIcon;var settingTitle=this.settingPanelTitle||this.title;this.newInstance=function(itemFactory){return function(id,settingPanelCallback,acceptedDimensions,context){return _react2.default.createElement(SettingPanelClass,{id:id,icon:settingIcon,title:settingTitle,context:context,save:function save(newParams){return itemFactory.saveItem(id,newParams,typeId);},preferredHeight:preferredHeight,preferredWidth:preferredWidth,acceptedDimensions:acceptedDimensions,settingPanelCallback:settingPanelCallback});};};return this;}/**
   * Adds mandatory behavior to the builder to indicate ItemClass and SettingPanelClass for existing items (when we need to restore them at refresh)
   *
   * @param {class} ItemClass - The class to use to instantiate the item. It's a class extending Item class, often in a .jsx format.
   * @param {class} SettingPanelClass - The class of setting panel to use to update item params. Extending ItemSettingPanel class, often in a .jsx format.
   * @returns {object} - This object, to chain methods
   * @public
   */},{key:'existingInstance',value:function existingInstance(ItemClass,SettingPanelClass){if(this.restoreInstance){throw new Error('You cannot call existingInstance() multiple times.');}var typeId=this.id;var settingIcon=this.settingPanelIcon;var settingTitle=this.settingPanelTitle||this.title;this.restoreInstance=function(itemFactory){return function(id,params,settingPanelCallback,acceptedDimensions,context){var itemLinker=new ItemLinker();var item=_react2.default.createElement(ItemClass,{id:id,initialParams:params,context:context,ref:function ref(c){return itemLinker.receiveItem(c);},acceptedDimensions:acceptedDimensions});var settingPanel=_react2.default.createElement(SettingPanelClass,{ref:function ref(c){return itemLinker.receiveItemSettingPanel(c);},icon:settingIcon,title:settingTitle,id:id,initialParams:params,item:item,context:context,save:function save(newParams){return itemFactory.saveItem(id,newParams,typeId);},acceptedDimensions:acceptedDimensions,settingPanelCallback:settingPanelCallback});return{item:item,settingPanel:settingPanel};};};return this;}/**
   * Optional call to add settings panel header attributes, to personalize title and icon.
   *
   * @param {string} title - Optional title, in English. Please keep it really short. Not much place to display it.
   * @param {string} icon - Optional icon id to show in the header.
   * @returns {object} - This object, to chain methods
   * @public
   */},{key:'settingPanelWithHeader',value:function settingPanelWithHeader(title,icon){this.settingPanelTitle=title;this.settingPanelIcon=icon;return this;}/**
   * Mandatory. Each call to this method will add accepted dimension
   *
   * @see https://github.com/gxapplications/asterism/blob/master/lib/plugins/navigation-tools/item-factory.jsx
   * @param {object[]} dimensions - Array of simple object of type { w: X, h: Y }, X between 1 to 3, Y between 1 to 5
   * @returns {object} - This object, to chain methods
   * @public
   */},{key:'acceptDimensions',value:function acceptDimensions(dimensions){this.dimensions=this.dimensions.concat(dimensions);return this;}/**
   * Once all characteristics are set in the builder, call this method to register item type into asterism.
   *
   * @returns {ItemFactoryBuilder} - The ItemFactoryBuilder instance, to chain with another ItemTypeBuilder
   * @public
   */},{key:'build',value:function build(){var _this4=this;var that=this;var itemType=function itemType(itemFactory){return{additionalItem:new _additionalItem2.default(itemFactory,that.id,that.title,that.category,that.description),newInstance:_this4.newInstance(itemFactory),restoreInstance:_this4.restoreInstance(itemFactory),dimensions:that.dimensions};};this.itemFactoryBuilder.itemsToBuild[this.id]=itemType;return this.itemFactoryBuilder;}}]);return ItemTypeBuilder;}();/**
* This class is used by a plugin to add item types. In an item factory (just one by plugin, referenced in the plugin manifest), we can specify many item types.
* See example for use.
*
* @see https://github.com/gxapplications/asterism/blob/master/lib/plugins/scenarii/item-factory.jsx
* @memberof module:Asterism
* @public
*/var ItemFactoryBuilder=function(){function ItemFactoryBuilder(){_classCallCheck(this,ItemFactoryBuilder);this.itemsToBuild={};}/**
   * To start a new item type build, call this method with a unique id and a category.
   *
   * Categories:
   * - AdditionalItem.categories.DOMOTICS,
   * - AdditionalItem.categories.SECURITY,
   * - AdditionalItem.categories.SCREENING,
   * - AdditionalItem.categories.COMMUNICATION,
   * - AdditionalItem.categories.INFORMATION,
   * - AdditionalItem.categories.DEVELOPMENT (to use only in dev mode, not shown in production mode)
   *
   * @param {string} id - A unique id to refer to this item type. Mandatory.
   * @param {string} category - A category to clissify item type.
   * @returns {ItemTypeBuilder} - A new ItemTypeBuilder instance, to begin describing an item type.
   * @public
   */_createClass(ItemFactoryBuilder,[{key:'newItemType',value:function newItemType(id,category){return new ItemTypeBuilder(this,id,category);}/**
   * When all item type are built, call this to validate the entire builder and obtain a class.
   * See example to know how to export the returned class.
   *
   * @param {class} - The class to instantiate an itemFactory. Should be kept as is (BasicItemFactory by default).
   * @returns {ItemTypeBuilder} - A class instance, extending the BaseClass given in the first parameter (often a BasicItemFactory).
   * @see https://github.com/gxapplications/asterism/blob/master/lib/plugins/scenarii/item-factory.jsx
   * @public
   */},{key:'build',value:function build(){var BaseClass=arguments.length>0&&arguments[0]!==undefined?arguments[0]:BasicItemFactory;var that=this;var itemsInjectorMixin=function itemsInjectorMixin(Clazz){return function(_Clazz){_inherits(_class,_Clazz);function _class(){_classCallCheck(this,_class);return _possibleConstructorReturn(this,(_class.__proto__||Object.getPrototypeOf(_class)).apply(this,arguments));}_createClass(_class,null,[{key:'generateItems',value:function generateItems(itemFactory){var keys=Object.keys(that.itemsToBuild);var items={};keys.forEach(function(k){items[k]=that.itemsToBuild[k](itemFactory);});return items;}}]);return _class;}(Clazz);};return itemsInjectorMixin(BaseClass);}}]);return ItemFactoryBuilder;}();ItemFactoryBuilder.ItemLinker=ItemLinker;exports.default=ItemFactoryBuilder;