'use strict';/* global $ */Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _propTypes=require('prop-types');var _propTypes2=_interopRequireDefault(_propTypes);var _react=require('react');var _react2=_interopRequireDefault(_react);var _uuid=require('uuid');var _uuid2=_interopRequireDefault(_uuid);var _patternlock=require('patternlock');var _patternlock2=_interopRequireDefault(_patternlock);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}/**
* This React component shows a pattern lock component, allowing to input a pattern code.
*
* @example <caption>Example of a patternLock. Use it in React JSX syntax</caption>
* <PatternLock theme={theme} animationLevel={animationLevel} patternCallback={this.patternJustDraw.bind(this)} />
*
* @see https://github.com/gxapplications/asterism/blob/master/lib/browser/edition/settings-security.jsx
* @hideconstructor
* @memberof module:Asterism
* @public
*/var PatternLock=function(_React$Component){_inherits(PatternLock,_React$Component);/**
   * React properties to use on this component.
   *
   * @property {object} theme - The asterism theme object. Often available from the parent component, or in the mainState object of a context.
   * @property {number} animationLevel - The asterism main parameter for visual animations. Often available from the parent component, or in the mainState object of a context.
   * @property {func} patternCallback - The callback method with the pattern once drawn correctly. The pattern is given as parameter, with digits separated by '-'.
   * @property {number} patternMinLength - The min length for input pattern. If draw is shorten than this number, an error style is shown for 3 seconds.
   * @property {bool} allowRepeat - This allows a pattern to use more than once the same node. Allowing this you can reach a very complicated pattern.
   * @public
   */function PatternLock(props){_classCallCheck(this,PatternLock);var _this=_possibleConstructorReturn(this,(PatternLock.__proto__||Object.getPrototypeOf(PatternLock)).call(this,props));_this.state={};_this._id='patternLock_'+_uuid2.default.v4();_this.lock=null;return _this;}/**
   * Default properties values.
   * @property {number} patternMinLength - 2
   * @property {boolean} allowRepeat - true
   * @public
   */_createClass(PatternLock,[{key:'componentDidMount',value:function componentDidMount(){var height=$('#'+this._id).parent().height();this.lock=new _patternlock2.default('#'+this._id,{lineOnMove:true,allowRepeat:this.props.allowRepeat,enableSetPattern:false,delimiter:'-',radius:height/14,margin:height/14,matrix:[3,3],onDraw:this.onDraw.bind(this)});}},{key:'componentWillUnmount',value:function componentWillUnmount(){this.lock=null;}},{key:'render',value:function render(){// const { animationLevel, theme } = this.props
return _react2.default.createElement('div',{className:'patternLock'},_react2.default.createElement('div',{id:this._id}));}},{key:'onDraw',value:function onDraw(pattern){var _this2=this;var patternArray=pattern.split('-');if(patternArray.length<this.props.patternMinLength){this._errorTimer=setTimeout(function(){if(_this2.lock){_this2.lock.reset();_this2.lock.enable();}},3000);this.lock.disable();return this.lock.error();}this._timer=setTimeout(function(){if(_this2.lock){_this2.lock.reset();_this2.lock.enable();}},1500);this.lock.disable();return this.props.patternCallback(pattern);}}]);return PatternLock;}(_react2.default.Component);PatternLock.propTypes={theme:_propTypes2.default.object.isRequired,animationLevel:_propTypes2.default.number.isRequired,patternCallback:_propTypes2.default.func.isRequired,patternMinLength:_propTypes2.default.number,allowRepeat:_propTypes2.default.bool};PatternLock.defaultProps={patternMinLength:2,allowRepeat:true};exports.default=PatternLock;