'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _uuid=require('uuid');var _uuid2=_interopRequireDefault(_uuid);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}/**
 * The ServerTrigger is the class you need to override to describe the behavior of you scenarii element (type trigger)
 * on the server side. A scenarii trigger element will be instantiated through this extending class on the server side.
 *
 * In your extending class, you MUST override these attributes:
 * - <YourClass>.get name()
 * - <YourClass>.reschedule()
 *
 * You can also override these attributes (optional):
 * - <YourClass>.constructor()
 *
 * You need also to override BrowserTrigger in another class to describe the browser side behavior of your trigger.
 *
 * Implementation example: see below.
 * @see https://github.com/gxapplications/asterism/blob/master/lib/plugins/scenarii/base-elements/level-state-trigger/server.js
 * @memberof module:Scenarii
 * @public
 * @abstract
 */var ServerTrigger=function(){/**
   * You can override the constructor.
   * Don't forget to pass data parameter to the super() constructor.
   *
   * @public
   */function ServerTrigger(data){_classCallCheck(this,ServerTrigger);this.data=data;this.listeners=[];}/**
   * Returns the name of the trigger instance (not the trigger type).
   * The name must be very short (limit to ~25 chars approximately).
   * It is often the name of the element that is looked through the trigger.
   *
   * eg.: "Room light sensor"
   *
   * @returns {string}
   * @public
   */_createClass(ServerTrigger,[{key:'reschedule',/**
   *
   *
   * @returns {Promise}
   * @public
   */value:function reschedule(){// See examples in asterism/plugins/scenarii/base-elements/*trigger
return Promise.resolve(true);}/** @private */},{key:'addListener',value:function addListener(listener){listener.triggerListenerId=_uuid2.default.v4();this.listeners.push(listener);return listener.triggerListenerId;}/** @private */},{key:'removeListener',value:function removeListener(listenerId){this.listeners=this.listeners.filter(function(listener){return listener.triggerListenerId!==listenerId;});}},{key:'name',get:function get(){return'ServerTrigger';}}]);return ServerTrigger;}();exports.default=ServerTrigger;