'use strict';/* global $ */Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _classnames=require('classnames');var _classnames2=_interopRequireDefault(_classnames);var _propTypes=require('prop-types');var _propTypes2=_interopRequireDefault(_propTypes);var _react=require('react');var _react2=_interopRequireDefault(_react);var _reactMaterialize=require('react-materialize');function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _toConsumableArray(arr){if(Array.isArray(arr)){for(var i=0,arr2=Array(arr.length);i<arr.length;i++){arr2[i]=arr[i];}return arr2;}else{return Array.from(arr);}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}/**
 * This React component shows a dropdown with available scenarii elements of 'trigger' type.
 * This is use to choose an existing trigger (that is public, so not inside another scenarii element like a procedure)
 * or to create a new one on the fly (optional).
 * You can filter triggers you want with a type filter as a callback, select default element, etc...
 *
 * @example <caption>Example of an TriggersDropdown. Use it in React JSX syntax</caption>
 * <TriggersDropdown defaultTriggerId={this.state.triggerId} onChange={this.triggerChanged.bind(this)}
 *   theme={theme} animationLevel={animationLevel} services={services} />
 *
 * @see https://github.com/gxapplications/asterism/blob/master/lib/plugins/scenarii/base-elements/actionable-scenario/edit-form.jsx#L63
 * @hideconstructor
 * @memberof module:Scenarii
 * @public
 */var TriggersDropdown=function(_React$Component){_inherits(TriggersDropdown,_React$Component);/**
   * React properties to use on this component.
   *
   * @property {object} services - The asterism services object. Often available from the parent component, or in the mainState object of a context.
   * @property {object} theme - The asterism theme object. Often available from the parent component, or in the mainState object of a context.
   * @property {number} animationLevel - The asterism main parameter for visual animations. Often available from the parent component, or in the mainState object of a context.
   * @property {string} defaultTriggerId - The trigger ID to pre-select at initialization.
   * @property {function} onChange - A callback when the user made a choice (in case of "new trigger" choice, called only after the element creation).
   * @property {string} dropdownId - An ID, just in order to be able to make a dom query on it...
   * @property {string} parentIdForNewInstance - Optional parent ID element for creation of a "new trigger" case. In that case, the new element will not appear in the main trigger list! None by default.
   * @property {string} label - The label to put above the input, in the user interface.
   * @property {string} icon - The icon to put on the left of the input, in the user interface.
   * @property {boolean} noCreationPanel - True to avoid opening a popin (a modal frame with settings of the new element). False by default.
   * @property {function} typeFilter - A filter to choose what type of new triggers can be created from the dropdown.
   * @property {function} instanceFilter - A filter to choose what existing public triggers should be listed in the dropdown.
   * @public
   */function TriggersDropdown(props){_classCallCheck(this,TriggersDropdown);var _this=_possibleConstructorReturn(this,(TriggersDropdown.__proto__||Object.getPrototypeOf(TriggersDropdown)).call(this,props));_this.scenariiService=props.services()['asterism-scenarii'];_this.state={instances:[],types:[],creatingInstance:null,currentId:props.defaultTriggerId};_this._editFormInstance=null;return _this;}/**
   * Default properties values.
   *
   * @property {string} defaultTriggerId - null (no selection, the first item will be selected at display time).
   * @property {string} dropdownId - '0' by default, to override if you need to query its DOM element.
   * @property {string} parentIdForNewInstance - null by default (so, public element shown in the triggers list).
   * @property {string} label - 'Trigger'.
   * @property {string} icon - 'play_circle_filled' (default icon for triggers).
   * @property {boolean} noCreationPanel - false (allows creation panel).
   * @property {function} typeFilter - () => true (allows all types).
   * @property {function} instanceFilter - () => true (allows all existing public triggers).
   * @public
   */_createClass(TriggersDropdown,[{key:'componentDidMount',value:function componentDidMount(){var _this2=this;this.scenariiService.getTriggerTypes().then(function(types){return _this2.scenariiService.getTriggerInstances().then(function(instances){instances=instances.filter(function(i){return!!i;}).filter(_this2.props.instanceFilter);_this2.setState({types:types.filter(_this2.props.typeFilter).map(function(type){return{id:type.id,type:type.type,onClick:function onClick(){_this2.scenariiService.createTriggerInstance(type.id).then(function(newTrigger){if(_this2.props.noCreationPanel){_this2.confirmNewInstance(newTrigger);}else{_this2.setState({creatingInstance:newTrigger});}});}};}),instances:instances});});});}},{key:'componentDidUpdate',value:function componentDidUpdate(){if(this.state.creatingInstance){$('#triggers-dropdown-modal-'+this.props.dropdownId).detach().appendTo('#app');$('#triggers-dropdown-modal-'+this.props.dropdownId).modal({dismissible:false});$('#triggers-dropdown-modal-'+this.props.dropdownId).modal('open');}}},{key:'render',value:function render(){var _this3=this;var _props=this.props,theme=_props.theme,animationLevel=_props.animationLevel,dropdownId=_props.dropdownId,services=_props.services,label=_props.label,icon=_props.icon,_props$children=_props.children,children=_props$children===undefined?[]:_props$children;var _state=this.state,types=_state.types,instances=_state.instances,creatingInstance=_state.creatingInstance,currentId=_state.currentId;var EditForm=creatingInstance&&creatingInstance.EditForm||null;var childrenCount=(children||[]).length>=0?(children||[]).length:1;return _react2.default.createElement('div',{id:'triggers-dropdown-modal-anchor-'+dropdownId},_react2.default.createElement(_reactMaterialize.Select,{s:12,label:label,icon:icon,onChange:this.valueChanged.bind(this),value:currentId||''},instances.length+childrenCount>0?_react2.default.createElement('option',{key:'no-option-choosed',value:'',disabled:true},'Please choose a trigger'):[],children||[],instances.map(function(instance,idx){return _react2.default.createElement('option',{key:instance.instanceId,value:instance.instanceId},instance.shortLabel);}),types.length>0?_react2.default.createElement('option',{key:'no-type-choosed',value:'',disabled:true},instances.length+childrenCount>0?'Or create a new one from these:':'Choose a trigger to create'):[],types.map(function(_ref,idx){var id=_ref.id,type=_ref.type,onClick=_ref.onClick;return _react2.default.createElement('option',{key:type.name,value:id},'+ ',type.shortLabel||type.name);})),creatingInstance?_react2.default.createElement('div',{id:'triggers-dropdown-modal-'+dropdownId,className:(0,_classnames2.default)('modal modal-fixed-footer triggers-dropdown-edit-panel',theme.backgrounds.body)},_react2.default.createElement('div',{className:'modal-content'},_react2.default.createElement('div',{className:(0,_classnames2.default)('coloring-header',theme.backgrounds.editing)},_react2.default.createElement('h4',null,EditForm.label||'Trigger configuration')),_react2.default.createElement('div',null,_react2.default.createElement(EditForm,{ref:function ref(c){_this3._editFormInstance=c;},instance:creatingInstance,services:services,theme:theme,animationLevel:animationLevel}))),_react2.default.createElement('div',{className:(0,_classnames2.default)('modal-footer',theme.backgrounds.body)},_react2.default.createElement('a',{href:'#!',onClick:this.confirmNewInstance.bind(this,creatingInstance),className:(0,_classnames2.default)('modal-action btn-flat',{'waves-effect waves-green':animationLevel>=3})},_react2.default.createElement(_reactMaterialize.Icon,{left:true},'check'),' Ok'),_react2.default.createElement('a',{href:'#!',onClick:this.cancelNewInstance.bind(this,creatingInstance),className:(0,_classnames2.default)('modal-action btn-flat',{'waves-effect waves-red':animationLevel>=3})},_react2.default.createElement(_reactMaterialize.Icon,{left:true},'clear'),' Cancel'))):null);}},{key:'valueChanged',value:function valueChanged(event){var currentId=event.currentTarget.value;var type=this.state.types.find(function(type){return type.id===currentId;});if(type){type.onClick();}else{this.setState({currentId:currentId});return this.props.onChange(currentId);}}},{key:'confirmNewInstance',value:function confirmNewInstance(creatingInstance){var _this4=this;this.scenariiService.setTriggerInstance(creatingInstance,this.props.parentIdForNewInstance).then(function(){var instances=[].concat(_toConsumableArray(_this4.state.instances),[creatingInstance]);$('#triggers-dropdown-modal-'+_this4.props.dropdownId).modal('close');$('#triggers-dropdown-modal-'+_this4.props.dropdownId).detach().appendTo('#triggers-dropdown-modal-anchor-'+_this4.props.dropdownId);_this4.setState({instances:instances,currentId:creatingInstance.instanceId,creatingInstance:null});_this4.props.onChange(creatingInstance.instanceId);});}},{key:'cancelNewInstance',value:function cancelNewInstance(creatingInstance){var _this5=this;$('#triggers-dropdown-modal-'+this.props.dropdownId).modal('close');$('#triggers-dropdown-modal-'+this.props.dropdownId).detach().appendTo('#triggers-dropdown-modal-anchor-'+this.props.dropdownId);setTimeout(function(){_this5.setState({creatingInstance:null});},250);this._editFormInstance=null;}}]);return TriggersDropdown;}(_react2.default.Component);TriggersDropdown.propTypes={services:_propTypes2.default.func.isRequired,theme:_propTypes2.default.object.isRequired,animationLevel:_propTypes2.default.number.isRequired,defaultTriggerId:_propTypes2.default.string,onChange:_propTypes2.default.func.isRequired,dropdownId:_propTypes2.default.string,parentIdForNewInstance:_propTypes2.default.string,label:_propTypes2.default.string,icon:_propTypes2.default.string,noCreationPanel:_propTypes2.default.bool,typeFilter:_propTypes2.default.func,instanceFilter:_propTypes2.default.func};TriggersDropdown.defaultProps={defaultTriggerId:null,dropdownId:'0',parentIdForNewInstance:null,label:'Trigger',icon:'play_circle_filled',noCreationPanel:false,typeFilter:function typeFilter(){return true;},instanceFilter:function instanceFilter(){return true;}};exports.default=TriggersDropdown;